using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DynoLib
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private DynoLib.DynoGraph dyno;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		DynoRun run1;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// 
			// dyno
			// 
			this.dyno.Dock = System.Windows.Forms.DockStyle.Fill;
			this.dyno.Location = new System.Drawing.Point(0, 0);
			this.dyno.Name = "dyno";
			this.dyno.Size = new System.Drawing.Size(292, 273);
			this.dyno.TabIndex = 0;
			//this.dyno.LineMode = DynoGraph.LINEMODE_LINE;
			
			IgnoreRule r = new IgnoreRule((int)DynoGraph.Indices.IND_TPS, 30f);
			dyno.addIgnoreRule(r,true);

			ArrayList data = new ArrayList();

			float[] arr = new float[5];
			arr[3] = 10.2f;

			arr[0] = 2000f;
			for(int i = 0; i<8; i++)
			{
				arr[0] += 500f;
				arr[1] += 50f;
				arr[2] += 20f;
				arr[3] += .5f;
				arr[4] += 10f;
				data.Add(new GraphItem(arr));
			}
			/*
			arr[0] = 3000f;
			arr[1] = 170f;
			arr[2] = 80f;
			arr[3] = 11.2f;

			arr[0] = 1000f;
			arr[1] = 120f;
			arr[2] = 20f;
			arr[3] = 10.2f;

			arr[0] = 2000f;
			arr[1] = 150f;
			arr[2] = 110f;
			arr[3] = 16.2f;
			*/
			//float[,] data = {{3000f,1000f,2000f,4000f,5000f,6000f,7000f},
			//				{170f,120f,150f,200f,330f,380f,360f},
			//				{80f,20f,70f,110f,130f,140f,120f},
			//				{11.2f,10.2f,16.2f,15.2f,12.2f,14.2f,13.2f}};
		//	run.SetGraphShowing(false,1);
			DynoRun run = new DynoRun("Yellow",Color.Yellow);
			run.RunData = data;
			run.SetAlphaChannel(100,2);
			//run.SetGraphShowing(false,(int)DynoGraph.Indices.IND_MIX);
			
			dyno.addDynoRun(run);
			
/*
			float[,] data1 = {{1000f,2000f, 3000f,4000f,5000f,6000f,7000f},
							{180f,200f,210f,250f,330f,340f,360f},
							{100f,110f,300f,350f,370f,360f,310f},
							{11.2f,11.5f,10.8f,11.3f,12.2f,11.3f,11.9f}};
			*/
			data = new ArrayList();

			arr = new float[4];
			arr[3] = 9f;
			for(int i = 0; i<8; i++)
			{
				arr[0] += 1000f;
				arr[1] += 50f;
				arr[2] += 20f;
				arr[3] += .5f;
				data.Add(new GraphItem(arr));
			}
			run1 = new DynoRun("White",Color.White);
			run1.RunData = data;
		//	run1.SetGraphShowing(false,3);

			dyno.addDynoRun(run1);

			tstDlg tst = new tstDlg(dyno);
			tst.Show();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dyno = new DynoLib.DynoGraph();
			this.SuspendLayout();
			// 
			// dyno
			// 
			this.dyno.LineMode = 0;
			this.dyno.Location = new System.Drawing.Point(0, 0);
			this.dyno.Name = "dyno";
			this.dyno.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(968, 629);
			this.Controls.Add(this.dyno);
			this.Name = "Form1";
			this.Text = "Dyno Graph Test";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			try
			{
				Application.Run(new Form1());
			}
			catch(Exception e)
			{
				MessageBox.Show(e.StackTrace);
			}
		}
	}
}
