using System;

namespace SimpleGrid
{
	/// <summary>
	/// Summary description for CellEvent.
	/// </summary>
	[Serializable] public class CellEvent : System.EventArgs
	{
		int column = -1;
		int row = -1;

		/// <summary>
		/// Get or set the row
		/// </summary>
		public int Row
		{
			get { return row; }
			set
			{
				if (value >= 0)
					row = value;
			}
		}

		/// <summary>
		/// Get or set the column
		/// </summary>
		public int Column
		{
			get { return column; }
			set
			{
				if (value >= 0)
					column = value;
			}
		}
		
		/// <summary>
		/// Plain ol' constructor
		/// </summary>
		public CellEvent()
		{
			//
			// TODO: Add constructor logic here
			//
		}
	}
}
