#include "stdafx.h"
#include "NGIgnMap.h"

RomRep::NGIgnMap::NGIgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,], 
						   unsigned char fil __gc[], int cscalarloc, int rscalarloc, 
						   int ind, int mod):Obd0IgnMap(x1,y1,loc,themap,fil,ind,mod)
{
	populate(themap);

	this->vtec = false;

	this->boost = false;
	if(ind > 0)
		this->boost = true;
	
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;

	RomRep::Pm6Ng::calcPressureHeaders(cscalarloc,vac,fil,boost);
	RomRep::Pm6Ng::calcRpmHeaders(rscalarloc,rpm,fil,boost);
}
