#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "DataLogForm.h"
#include "Obd0VtecLogPage.h"


namespace bre20
{

	public __gc class Vt0Logger : public bre20::DataLogForm
	{
	public:
		
		Vt0Logger(child * romm);
		Vt0Logger(bool NA,child * romm);

	private:
		int realtick;
		int divisions;
		int iteration;
		String * curline;
		String * nextline;

		

		bool na;

		bre20::Vt0LogPage * textLog;


		int getAverage(String * s,String * s2);
		float getAverageD(String * s,String * s2);

		void init();

	protected:
		virtual void runDL();
		virtual void runReplay();
		virtual void logStart();
		virtual void logStop();

	//	virtual float pickO2(unsigned char cmd);


		String * intToBin(int num);

	};

}