
#pragma once
using namespace System;

#include "global.h"
//#include "LoggerData.h"

namespace bre20
{
	/*!
	*/
	public __gc class DynoCalculation
	{
	private:
		double interval; //milliseconds
		int mintps;
		bool sae;

		float weight, gear, fdr, tireh, cd, frontArea;

		void prop_Changed(Object* sender, PropertyEventArgs* pe);

		float calcTq(float newrpm, float oldrpm);
		float calcHp(float tq, float rpm);

	public:
		DynoCalculation(int interval);

		void recalculate(DynoLib::DynoRun* run);
		float calculate(float lastVals __gc[]) __gc[]; //recalculate
		DynoLib::GraphItem* calculate(__int64 lasttime,float lastVals __gc[], __int64 curtime, float curvals __gc[]);

		void setInterval(int inter);

		int getMinTps(){return mintps;};
	};
}