#include "stdafx.h"
#include "GhdPm6.h"


RomRep::GhdPm6::GhdPm6(): Pm6(){}
RomRep::GhdPm6::~GhdPm6()
{
//	delete idle;
//	delete launchlimit;
}

RomRep::GhdPm6::GhdPm6(unsigned char rom __gc[], int flen): Pm6(rom, flen, 0x0DE6, 0x0, 0x3EFE, 0x3FFD,0x3DFF,0,0,0,1, "Ghd Pm6",0x399f)
{
	checksumaddy = 0x4418;
	checksumlen = 0x5000;
	int launchaddy = 0x40EB;
//	int idleaddy = 0x399F;

//	idle = new RpmTwoByteValue(idleaddy, rom[idleaddy], idleaddy+2, rom[idleaddy]);
	launchlimit = new RpmTwoByteValue(launchaddy, rom[launchaddy],launchaddy+2,rom[launchaddy+2]);
//(unsigned char rom __gc[], int flen, int revloc, int restartloc, int fmaploc, int fmltloc, int imaploc, string type);
}
/*
			fuelmap1addy = 0x3EFE;
			fuelmltaddy = 0x3FFD;

			ignmap1addy = 0x3DFF;

			revaddy = 0x0DE6;
			idleaddy = 0x399F;
		
			launchaddy = 0x40EB; 
			checksumaddy = 0x4418;
			checksumlen = 0x5000;

			m_staticecu.Format("ECU: GhD PM6");
*/
int RomRep::GhdPm6::getLaunchLimit()//returns RPM
{
	return getRpmValue(launchlimit);
}
//int RomRep::GhdPm6::getIdle()//returns RPM
//{
//	return getRpmValue(idle);
//}
void RomRep::GhdPm6::setLaunchLimit(int rpm)
{
	setRpmValue(launchlimit, rpm);
}
//void RomRep::GhdPm6::setIdle(int rpm)
//{
//	setRpmValue(idle,rpm);
//}
bool RomRep::GhdPm6::validate(unsigned char h __gc[])
{
	int head[10] = {0x02,0x16,0x03,0xC0,0xE0,0xC0,0x83,0xC0,0x82,0x61}; //pm6

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
			return false;

	return true;
}
