#pragma once
#include "gridpage.h"
#include "common.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace bre20
{
	/// <summary> 
	/// Summary for IgnRetardDialog
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class IgnRetardDialog : public System::Windows::Forms::Form
	{
	public: 
		IgnRetardDialog(GridPage* gp, int lnacol)
		{
			page = gp;
			lastnacol = lnacol;
			InitializeComponent();
		}
        
	protected: 
		GridPage* page;
		int lastnacol;
	
			 


		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

	private: System::Windows::Forms::RadioButton *  selCells;
	private: System::Windows::Forms::Button *  okButton;
	private: System::Windows::Forms::Button *  cancelButton;
	private: System::Windows::Forms::RadioButton *  allBoostCol;
	private: System::Windows::Forms::RadioButton *  selBoostCol;

	private: System::Windows::Forms::GroupBox *  retardArea;
	private: System::Windows::Forms::Button *  helpButton;
	private: System::Windows::Forms::TextBox *  retardBox;
	private: System::Windows::Forms::Label *  label1;

	private:
		//actually does the work in retarding the ignition
		void retardIgnition(float amount);

		void retardWorker(int selectedcells __gc[], float amount);
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container* components;

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->okButton = new System::Windows::Forms::Button();
			this->cancelButton = new System::Windows::Forms::Button();
			this->allBoostCol = new System::Windows::Forms::RadioButton();
			this->selBoostCol = new System::Windows::Forms::RadioButton();
			this->selCells = new System::Windows::Forms::RadioButton();
			this->retardArea = new System::Windows::Forms::GroupBox();
			this->helpButton = new System::Windows::Forms::Button();
			this->retardBox = new System::Windows::Forms::TextBox();
			this->label1 = new System::Windows::Forms::Label();
			this->retardArea->SuspendLayout();
			this->SuspendLayout();
			// 
			// okButton
			// 
			this->okButton->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->okButton->Location = System::Drawing::Point(176, 136);
			this->okButton->Name = S"okButton";
			this->okButton->Size = System::Drawing::Size(56, 32);
			this->okButton->TabIndex = 1;
			this->okButton->Text = S"Apply";
			this->okButton->Click += new System::EventHandler(this, okButton_Click);
			// 
			// cancelButton
			// 
			this->cancelButton->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->cancelButton->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->cancelButton->Location = System::Drawing::Point(112, 136);
			this->cancelButton->Name = S"cancelButton";
			this->cancelButton->Size = System::Drawing::Size(56, 32);
			this->cancelButton->TabIndex = 2;
			this->cancelButton->Text = S"Close";
			this->cancelButton->Click += new System::EventHandler(this, cancelButton_Click);
			// 
			// allBoostCol
			// 
			this->allBoostCol->Checked = true;
			this->allBoostCol->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->allBoostCol->Location = System::Drawing::Point(16, 72);
			this->allBoostCol->Name = S"allBoostCol";
			this->allBoostCol->Size = System::Drawing::Size(120, 16);
			this->allBoostCol->TabIndex = 3;
			this->allBoostCol->TabStop = true;
			this->allBoostCol->Text = S"All Boost Columns";
			// 
			// selBoostCol
			// 
			this->selBoostCol->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->selBoostCol->Location = System::Drawing::Point(16, 48);
			this->selBoostCol->Name = S"selBoostCol";
			this->selBoostCol->Size = System::Drawing::Size(152, 16);
			this->selBoostCol->TabIndex = 4;
			this->selBoostCol->Text = S"Selected Boost Columns";
			// 
			// selCells
			// 
			this->selCells->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->selCells->Location = System::Drawing::Point(16, 24);
			this->selCells->Name = S"selCells";
			this->selCells->Size = System::Drawing::Size(128, 16);
			this->selCells->TabIndex = 5;
			this->selCells->Text = S"Selected Cells";
			// 
			// retardArea
			// 
			this->retardArea->Controls->Add(this->helpButton);
			this->retardArea->Controls->Add(this->allBoostCol);
			this->retardArea->Controls->Add(this->selBoostCol);
			this->retardArea->Controls->Add(this->selCells);
			this->retardArea->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->retardArea->Location = System::Drawing::Point(8, 8);
			this->retardArea->Name = S"retardArea";
			this->retardArea->Size = System::Drawing::Size(224, 104);
			this->retardArea->TabIndex = 8;
			this->retardArea->TabStop = false;
			this->retardArea->Text = S"Ignition Retard Area";
			// 
			// helpButton
			// 
			this->helpButton->FlatStyle = System::Windows::Forms::FlatStyle::System;
			this->helpButton->Location = System::Drawing::Point(160, 72);
			this->helpButton->Name = S"helpButton";
			this->helpButton->Size = System::Drawing::Size(56, 24);
			this->helpButton->TabIndex = 6;
			this->helpButton->Text = S"Help";
			this->helpButton->Click += new System::EventHandler(this, helpButton_Click);
			// 
			// retardBox
			// 
			this->retardBox->Location = System::Drawing::Point(8, 144);
			this->retardBox->Name = S"retardBox";
			this->retardBox->Size = System::Drawing::Size(80, 20);
			this->retardBox->TabIndex = 0;
			this->retardBox->Text = S"";
			this->retardBox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, retardBox_KeyPress);
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(8, 128);
			this->label1->Name = S"label1";
			this->label1->Size = System::Drawing::Size(96, 16);
			this->label1->TabIndex = 7;
			this->label1->Text = S"deg. /lb retard:";
			// 
			// IgnRetardDialog
			// 
			this->AcceptButton = this->okButton;
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->CancelButton = this->cancelButton;
			this->ClientSize = System::Drawing::Size(242, 176);
			this->Controls->Add(this->retardBox);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->retardArea);
			this->Controls->Add(this->cancelButton);
			this->Controls->Add(this->okButton);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = S"IgnRetardDialog";
			this->ShowInTaskbar = false;
			this->Text = S"Ignition Retard";
			this->retardArea->ResumeLayout(false);
			this->ResumeLayout(false);

		}		
	private: System::Void retardBox_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 Common::handleDoubleKeyPress(static_cast<TextBox*>(sender),e,true);
			 }

private: System::Void okButton_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 float retard;
			 try
			 {
				 if(retardBox->Text->Equals(""))
					 throw new Exception();
				retard = Convert::ToSingle(retardBox->Text);
			 }
			 catch(...)
			 {
				 retardBox->Text = "";
				 MessageBox::Show("The number entered was not valid","BRE");
				 return;
			 }

			 retardIgnition(retard);

		 }

private: System::Void cancelButton_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 this->Visible = false;
		 }

private: System::Void helpButton_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 MessageBox::Show("The area options tell BRE where to do the retard calculations.\n\nAll Boost Columns: This option will apply the ignition retard to the entire boost portion of the ignition map(s). Think of it as 'linear' retard. \n\nSelected Boost Columns: This option will apply the ignition retard to any boost columns that have a cell selected. This is like the 'step' retard. \n\nSelected Cells: This option will apply the retard to the selected cells only.\n\nKeep in mind this is degrees retard so a positive value will result in LESS ignition, and a negative value more.", "(Ignition) Retard Help");
		 }

};
}