//
//#pragma once
//#if !defined BENSs_JDMOBD0PR3BOOSTECU_H
//#define BENSs_JDMOBD0PR3BOOSTECU_H

#pragma once
using namespace System;

#include "Obd0VtecEcu.h"
namespace RomRep
{
	public __gc class JdmPr3Boost: public VT0Ecu
	{
	public:
		JdmPr3Boost();
		JdmPr3Boost(int* rom, int flen);

		virtual void disableChecksum(bool disable); 
		virtual void disableOxygenSensors(bool disable);

		virtual void setLaunchRpm(int val);
		virtual void setLaunchSpeed(int val);
		virtual void enableLaunch(bool enable);
		virtual void disableSpeedLimiter(bool disable); 
		virtual void disableVssCheck(bool disable); 
		virtual void disableTempCheck(bool disable); 
		virtual void disablePsCheck(bool disable); 
		virtual void disableCelCheck(bool disable);
		virtual int isKnockSensorDisabled();
		virtual void disableKnockSensor(bool disable);

		virtual int getLaunchRpm();
		virtual int getLaunchSpeed();

		virtual int isSpeedLimiterDisabled();
		virtual int isVssCheckDisabled();
		virtual int isTempCheckDisabled();
		virtual int isCelCheckDisabled();
		virtual int isPsCheckDisabled();
		virtual int isLaunchDisabled();

		virtual int isChecksumDisabled();
		virtual int isOxygenSensorsDisabled();

		static bool validate(int* h);
	};
}

//#endif