#include "stdafx.h"
#include "LoggerGrid.h"
#include "LoggerData.h"

bre20::LoggerGrid::LoggerGrid(int width,int height): SimpleGrid::Grid()
{
	this->PaintMode = SimpleGrid::Grid::M_PAINT_NO_COLORS;
	this->BackColor = System::Drawing::Color::White;
	this->GridSize = System::Drawing::Size(2,1);
	this->RowHeaderWidth = 0;
	this->RowHeight = 18;
	this->ReadOnly = true;
	this->Size = System::Drawing::Size(width,height);
	this->setColumnWidth(0,width/2);
	this->setColumnWidth(1,width/2 -1);
	this->setHeader(0,"Key");
	this->setHeader(1,"Value");
}

void bre20::LoggerGrid::InitGrid(ArrayList* newvals)
{
	int i, count = 0;
	for(i = 0; i<newvals->Count; i++)
		if(static_cast<LoggerKey*>(newvals->get_Item(i))->ToGrid)
			count++;
	this->GridSize = System::Drawing::Size(2,count);
//	UpdateGrid(newvals);
}
//
//void bre20::LoggerGrid::UpdateGrid(ArrayList* newvals)
//{
////	this->GridSize = System::Drawing::Size(2,newvals->Count);
//	LoggerKey* key;
//	for(int i = 0; i<newvals->Count; i++){
//		key = static_cast<LoggerKey*>(newvals->get_Item(i));
//		if(key->Label != NULL)
//			this->setValue(0,i, key->Label);
//		if(key->Value != NULL)
//			this->setValue(1,i, key->Value);
//	}
//}

void bre20::LoggerGrid::setKeyValue(int row, String* value)
{
	if(value != NULL)
		this->setValue(1,row,value);
}
void bre20::LoggerGrid::setKeyValue(int row, String* key, String* value)
{
	if(value != NULL)
		this->setValue(1,row,value);
	if(key != NULL)
		this->setValue(0,row,key);
}