#include "stdafx.h"
#include "Pm6.h"


RomRep::Pm6::Pm6(): Obd0Ecu(){}
RomRep::Pm6::~Pm6()
{
//	delete idle;
//	delete launchlimit;
}

RomRep::Pm6::Pm6(unsigned char rom __gc[], int flen): Obd0Ecu(rom, flen, 0x0DE6, 0x0, 0x3EF2, 0x3FF1,0x3DF3,0,0,0,1, "90-91 Pm6")
{
	checksumaddy = 0x43af;
	checksumlen = 0x8000;
	int idleaddy = 0x3993;

	idle = new RpmTwoByteValue(idleaddy, rom[idleaddy], idleaddy+2, rom[idleaddy]);
//	launchlimit = new RpmTwoByteValue(launchaddy, rom[launchaddy],launchaddy+2,rom[launchaddy+2]);
//(unsigned char rom __gc[], int flen, int revloc, int restartloc, int fmaploc, int fmltloc, int imaploc, string type);
}
RomRep::Pm6::Pm6(unsigned char rom __gc[], int flen, int revloc, int restartloc, int fmaploc, 
				 int fmltloc, int imaploc, int fmaploc1, int fmltloc1, 
				 int imaploc1, int nummaps, String* type, int idleaddy): Obd0Ecu(rom, flen, revloc,restartloc, fmaploc, fmltloc,imaploc,0,0,0,1, type)
{
	idle = new RpmTwoByteValue(idleaddy, rom[idleaddy], idleaddy+2, rom[idleaddy]);
	checksumaddy = 0x43af;
	checksumlen = 0x43b0;
}
/*
			fuelmap1addy = 0x3EFE;
			fuelmltaddy = 0x3FFD;

			ignmap1addy = 0x3DFF;

			revaddy = 0x0DE6;
			idleaddy = 0x399F;
		
			launchaddy = 0x40EB; 
			checksumaddy = 0x4418;
			checksumlen = 0x5000;

			m_staticecu.Format("ECU: GhD PM6");
*/

int RomRep::Pm6::getIdle()//returns RPM
{
	return getRpmValue(idle);
}

void RomRep::Pm6::setIdle(int rpm)
{
	setRpmValue(idle,rpm);
}
bool RomRep::Pm6::validate(unsigned char h __gc[])
{
	int head[10] = {0x02,0x16,0x00,0xC0,0xE0,0xC0,0x83,0xC0,0x82,0x61};
				 //{0x02,0x16,0x03,0xC0,0xE0,0xC0,0x83,0xC0,0x82,0x61}; //pm6

	for(int i = 0; i<HondaEcu::headlen; i++)
		if(head[i] != h[i])
			return false;

	return true;
}
