//#pragma unmanaged
//
//#pragma once
//#if !defined BENSs_OBD0PM6ECU_H
//#define BENSs_OBD0PM6ECU_H

#pragma once
using namespace System;

#include "Obd0NonVtecEcu.h"
#include "RpmValue.h"
namespace RomRep
{
	[Serializable] public __gc class Pm6: public Obd0Ecu
	{
	protected:
		RpmTwoByteValue* idle;
	public:
		Pm6();
		~Pm6();
		Pm6(unsigned char rom __gc[], int flen);
		Pm6(unsigned char rom __gc[], int flen, int revloc, int restartloc, int fmaploc, int fmltloc, int imaploc, int fmaploc1, int fmltloc1, int imaploc1, int nummaps, String* type, int idleaddy);
//		virtual int getLaunchLimit();//returns RPM
		virtual int getIdle();//returns RPM
//		virtual void setLaunchLimit(int rpm);
		virtual void setIdle(int rpm);

		static bool validate(unsigned char h __gc[]);

		virtual ByteChange* setAfrCellEx(int x, int y, float val, int index)
		{return NULL;};
	};
}

//#endif