#pragma unmanaged

#if !defined BENS_ROMENGINE_H
#define BENS_ROMENGINE_H
//#pragma once

#include <string>
#include <fstream>
#include <iostream>
#include "JdmPw0.h"
#include <cstdlib>
//#include "map.h"

using namespace std;

namespace RomRep
{
	class Engine
	{

	private:
		//static double xovervolts;
	public:
		Engine();

		static int* getFile(const char* fname, int size); //size in num of bytes
		static bool doesFileExist(const char* fname); //can call before getRom() 
		static HondaEcu* getRom(const char* fname, int size); //HondaEcu*
		//export map

		static bool saveFile(int* rom,const char* fname, int size);
		//import map


		//utils
		static void appendStr(string* s, string s2);
		static string toStr(int val);
		static string toStr(double val);
		static char * intToBin(int v);

		static double voltsToPsi(double volts, int sensor);
		static int voltsToInHg(double volts, int sensor);
		static int psiToRaw(double psi, int sensor);
		static int inHgToRaw(int inhg, int sensor);
		static double rawToVolts(int raw);
		static double rawToAfr(int raw, double volts[], double afr[]);
	};
}

#endif