#include "stdafx.h"
#include "FuelMap.h"

RomRep::FuelMap::FuelMap(int crap):Map()
{
	mult = new int[1];
	mult[0] = crap;
}

RomRep::FuelMap::FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1):Map(x1,y1,loc)
{
	mult = new int[x1];
	multloc = multloc1;
}

RomRep::FuelMap::FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, int* mltarray):Map(x1,y1,loc)
{
	mult = new int[x1];

	for(int i = 0; i<x1; i++)
		mult[i] = mltarray[i];

	multloc = multloc1;
}

RomRep::FuelMap::FuelMap(int x1, int y1, unsigned int loc, unsigned int multloc1, int* mltarray,int* fil):Map(x1,y1,loc,fil)
{
	mult = new int[x1];

	for(int i = 0; i<x1; i++)
		mult[i] = mltarray[i];

	multloc = multloc1;
}

RomRep::FuelMap::~FuelMap()
{
	delete[] mult;
}

void RomRep::FuelMap::insertColumn(int column) //column inserted AFTER 'column'
{
	Map::insertColumn(column);

	int* tmpmult = mult;

	mult = new int[x];

	for(int col = 0; col<x; col++)
	{
		if(col<=column)
		{
			mult[col] = tmpmult[col];
			thefile[this->getCellLocation(col,y)] = tmpmult[col];
		}
		else if(col == column+1)
		{
			mult[col] = tmpmult[column];
			thefile[this->getCellLocation(col,y)] = tmpmult[column];
		}
		else if(col> column+1)
		{
			mult[col] = tmpmult[col-1];
			thefile[this->getCellLocation(col,y)] = tmpmult[col-1];
		}
	}

}

void RomRep::FuelMap::setMultiplier(int column, int val)
{
	mult[column] = val;
}

int RomRep::FuelMap::getMultiplierLocation(int column)
{
	return multloc + column;
}