
#pragma once
#if !defined BENSs_JDMOBD0PR3ITBECU_H
#define BENSs_JDMOBD0PR3ITBECU_H

#include "JdmPr3.h"
namespace RomRep
{
	class JdmPr3ITB: public JdmPr3
	{
	//private:
		

	protected:
		
		int scalarloc;
		int xoverloc;
		virtual void setupHeaders();
		

	public:
		JdmPr3ITB();
		JdmPr3ITB(int* rom, int flen);

		int getTPSXOver()
		{
			return thefile[xoverloc];
		}

		int getTPSXOverColumn()
		{
			int mapcolumns[14] = {0xb,0x20,0x28,0x30,0x38,0x40,0x48,0x50,0x58,0x60,0x68,0x70,0x80,0x90}; 

			int* scalars = getArray(thefile,scalarloc+4,30);
			int xover = thefile[xoverloc];

			for(int i = 0; i<14 && xover>=mapcolumns[i]; i++);
			int index = i-1; //the column where the ecu starts using the tps;

			return index;
		}

		void setTPSXOver(int xover)
		{
			setByte(xoverloc, xover);
			setupHeaders();
		}

		static bool validate(int* h);
		static string toStr(int per);
	};
}
//ostream& operator<<(ostream& out, JdmPw0& pw0);

#endif