#pragma unmanaged

#if !defined BENS_VT0FUELMAP_H
#define BENS_VT0FUELMAP_H

#include "FuelMap.h"
#include <Cmath>

namespace RomRep
{
	class VT0FuelMap : public FuelMap
	{

	public:
		
		VT0FuelMap(int crap = 0);
		VT0FuelMap(int x, int y);
		VT0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc);
		VT0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc, int* mltarray);
		VT0FuelMap(int x, int y,unsigned int loc, int** themap, unsigned int multloc, int* mltarray,int* fil);

		virtual ~VT0FuelMap();

		virtual void setVal(int x, int y, int val);

		virtual double calculate(int x, int y, int intval);
		virtual int calculate(int x, int y, double mapval);

		void getMultipliers(int x, double* mlts);

		virtual void populate(int ** map);
		virtual void populate(int ** map, int * mltarray);

		
	};
}

//	ostream& operator<<(ostream& out, VT0FuelMap& fm);

#endif