#include "stdafx.h"
#include "Obd0VTECIgnMap.h"


VT0IgnMap::VT0IgnMap(int crap):Map(){}

VT0IgnMap::VT0IgnMap(int x1, int y1, unsigned int loc):Map(x1,y1,loc){}

VT0IgnMap::VT0IgnMap(int x1, int y1, unsigned int loc, int** themap):Map(x1,y1,loc)
{
	populate(themap);
}

VT0IgnMap::~VT0IgnMap(){}

//---------------------------------------------------

void VT0IgnMap::populate(int **mapp)
{
	int i, j;

	for(i = 0; i<x; i++)
		for(j = 0; j<y; j++)
			map[i][j] = calculate(i, j, mapp[i][j]);
}

void VT0IgnMap::setVal(int x1, int y1, int val)
{
	double mapval;

	mapval = calculate(x1, y1, val);

	map[x1][y1] = mapval; //sets a double into the internal map
}

double VT0IgnMap::calculate(int x1, int y1, int intval)
{
	return (((double)intval - 15.0) * 9.0) / 25.0;

}

int VT0IgnMap::calculate(int x1, int y1, double mapval)
{
	return (int)(((mapval*25)/9)+15);
}


//----------------------------------non-member functions---
/*
ostream& operator<<(ostream& out, VT0IgnMap& im)
{
	int i,j;

	for(j = 0; j<im.getY(); j++)
	{
		for(i = 0; i<im.getX(); i++)
			out<<im.getVal(i,j)<< " ";

		out<<endl;
	}
	out<< endl;

	return out;
}
*/