#pragma unmanaged

#pragma once
#if !defined BENSs_OBD0PM6ECU_H
#define BENSs_OBD0PM6ECU_H

#include "Obd0NonVtecEcu.h"
#include "RpmValue.h"
namespace RomRep
{
	class Pm6: public Obd0Ecu
	{
	protected:
		RpmTwoByteValue* idle;
	public:
		Pm6();
		~Pm6();
		Pm6(int* rom, int flen);
		Pm6(int* rom, int flen, int revloc, int restartloc, int fmaploc, int fmltloc, int imaploc, int fmaploc1, int fmltloc1, int imaploc1, int nummaps, string type, int idleaddy);
//		virtual int getLaunchLimit();//returns RPM
		virtual int getIdle();//returns RPM
//		virtual void setLaunchLimit(int rpm);
		virtual void setIdle(int rpm);

		static bool validate(int* h);

		virtual ByteChange* setAfrCellEx(int x, int y, double val, int index)
		{return NULL;};
	};
}

#endif