#pragma unmanaged

#pragma once
#if !defined BENSs_OBD0NGPM6ECU_H
#define BENSs_OBD0NGPM6ECU_H

#include "Obd0NonVtecEcu.h"
#include "RpmValue.h"
namespace RomRep
{
	class Pm6Ng: public Obd0Ecu
	{
	protected:
		int fmaploc1, fmltloc1, igmaploc1;

		RpmTwoByteValue* idle;
		RpmTwoByteValue* launchlimit;

		RpmTwoByteValue* vtec;

		//need an idle array too

	public:
		Pm6Ng();
		~Pm6Ng();
		Pm6Ng(int* rom, int flen);
		virtual int getLaunchLimit();//returns RPM
		virtual int getIdle();//returns RPM
		virtual void setLaunchLimit(int rpm);
		virtual void setIdle(int rpm);

		static bool validate(int* h);
	};
}

#endif