//temporary!

using System;
using System.Windows.Forms;
using bre20;
//css_reference ..\bre.exe;

namespace BensScripts
{
	public class O2Disable
	{
		private static int PR3ADD = 0x255;    //ce0f -> cb0b 
		private static int EPW0ADD = 0x25a;   //E06201 -> 670080
		private static int JPW0ADD = 0x26b;   //ce04 -> 0000

		private static int PR3 = 0;
		private static int EPW0 = 1;
		private static int JPW0 = 2;
		
		private child romWind;
		private MenuItem mitem;
		private bool enabled;
		private int type;

		public static object AppliesTo(){return "pr3:pw0";}
		public static object ScriptTitle(){return "Temporary o2 disable by Ben Ogle";}

		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];

			string stype = romWind.getRomType();
			if(Common.isMatch("jdm pr3",stype,false))
			{
				enabled = romWind.getRom().getByte(PR3ADD) == 0xce;
				type = PR3;
			}
			else if(Common.isMatch("jdm pw0",stype,false))
			{
				enabled = romWind.getRom().getByte(JPW0ADD) == 0xce;
				type = JPW0;
			}
			else if(Common.isMatch("euro pw0",stype,false))
			{
				enabled = romWind.getRom().getByte(EPW0ADD) == 0xe0;
				type = EPW0;
			}

			string s;
			if(enabled)
				s = "Disable";
			else
				s = "Enable";

			mitem = romWind.AddMenuItem("Scripts", s+" O2 sensors", "BensScripts.O2Disable.mnu_click");
			return null;
		}

		public object mnu_click(params object[] objs)
		{
			//private static int PR3ADD = 0x255;    //ce0f -> cb0b 
			//private static int EPW0ADD = 0x25a;   //E06201 -> 670080
			//private static int JPW0ADD = 0x26b;   //ce04 -> 0000
			RomRep.HondaEcu rom = romWind.getRom();
			if(enabled)
			{
				if(type == PR3)
				{
					rom.setByte(PR3ADD,0xcb);
					rom.setByte(PR3ADD+1,0x0b);
				}
				else if(type == JPW0)
				{
					rom.setByte(JPW0ADD,0x00);
					rom.setByte(JPW0ADD+1,0x00);
				}
				else if(type == EPW0)
				{
					rom.setByte(EPW0ADD,0x67);
					rom.setByte(EPW0ADD+1,0x00);
					rom.setByte(EPW0ADD+2,0x80);
				}
			}
			else
			{
				if(type == PR3)
				{
					rom.setByte(PR3ADD,0xce);
					rom.setByte(PR3ADD+1,0x0f);
				}
				else if(type == JPW0)
				{
					rom.setByte(JPW0ADD,0xce);
					rom.setByte(JPW0ADD+1,0x04);
				}
				else if(type == EPW0)
				{
					rom.setByte(EPW0ADD,0xe0);
					rom.setByte(EPW0ADD+1,0x62);
					rom.setByte(EPW0ADD+2,0x01);
				}
			}

			enabled = !enabled;
			string s;
			if(enabled)
				s = "Disable";
			else
				s = "Enable";
			if(enabled)
				mitem.Text = s+" O2 sensors";

			return null;
		}
	}//end class
}//end namespace