using System;
using System.Windows.Forms;

using bre20;
using RomRep;

//css_reference ..\bre.exe;
//css_reference ..\SimpleGrid.dll;

//This script opens all roms not openable by BRE as
//JDM PW0s. It is for demonstration purposes.

namespace BensScripts
{
	public class NewRom
	{
		Form1 mainWind;
		child romWind;

		public static object OnOpenRom(ref OnOpenRomArgs ra)
		{
			//Did BRE already find a suitable ROM type?
			//if so, return NULL
			if(ra.getRom() != null)
				return null;

			//otherwise open all not openable stuff as a JDM PW0
			ra.setOpenable(true);
			HondaEcu ecu = new JdmPw0(Engine.getFile(ra.getFilename(),0x8000),0x8000);
			ra.setRom(ecu);
			ra.setParamPage(new ParamPage(ecu));

			return null;
		}
		
		public static object AppliesTo()
		{
			return "pw0";
		}
		
		//again, ABSOLUTELY necessary
		//this is the string that shows up in the manager window
		public static object ScriptTitle()
		{
			return "Sample New Rom Script by Ben Ogle";
		}

		public object ScriptMain(params object[] args)
		{
			mainWind = (Form1)args[0];
			romWind = (child)args[1];
			
			return null;
		}

		public object chk_click(params object[] args)
		{

			return null;
		}
	}
}
