using System;
using System.Windows.Forms;

using bre20;
using RomRep;
//css_reference ..\bre.exe;

//this script is supposed to arrange the controls on the 
//script tab. That way, it will be semi-versatile in that
//each script doesnt need to claim its own real estate 
//on the tab page.

namespace BensScripts
{
	public class ScriptArrange
	{
		child romWind;
		private static int divide = 12;

		public static object AppliesTo()
		{
			return "all";
		}

		public static object Priority()
		{
			return 1;
		}
		
		public static object ScriptTitle()
		{
			return "Script Control Arrange by Ben Ogle";
		}


		//args[0] = main window of type bre20.Form1
		//args[1] = child window of type bre20.child
		public object ScriptMain(params object[] args)
		{
			romWind = (child)args[1];
			romWind.subscribeToEvent("OnAddControl", "BensScripts.ScriptArrange.control_Added").ToString();
			return null;
		}

		//the params are:
		
		public object control_Added(params object[] args)
		{

			if(args[2] != null)
				MessageBox.Show(args[2].ToString());

			return null;
		}

	}//end class
}//end namespace