using System;

namespace DynoLib
{
	/// <summary>
	/// Summary description for DynoPopupData.
	/// </summary>
	public class DynoPopupData
	{
		private string runName;
		private float rpm, afr, hp, tq;

		#region Properties
		public string RunName
		{
			get{ return runName; }
			set{ runName = value; }
		}
		public float RPM
		{
			get{ return rpm; }
			set{ rpm = value; }
		}
		public float AFR
		{
			get{ return afr; }
			set{ afr = value; }
		}
		public float HorsePower
		{
			get{ return hp; }
			set{ hp = value; }
		}
		public float Torque
		{
			get{ return tq; }
			set{ tq = value; }
		}
		#endregion

		public DynoPopupData()
		{
		}

		public string[] getStrings()
		{
			return new string[] {"Run:\t" + runName, "RPM:\t" + rpm.ToString("0"),
					"HP: \t" + hp.ToString("0.0"), "TQ:\t" + tq.ToString("0.0"), 
					"Mix:\t" + afr.ToString("0.00")};
		}

		public override string ToString()
		{
			return "Run: " + runName + "\nRPM: " + rpm.ToString("0") + "\nHP: " + hp.ToString("0.0") +
				"\nTQ: " + tq.ToString("0.0") + "\nMix: " + afr.ToString("0.00");
		}

	}
}
