using System;
using System.Drawing;

namespace DynoLib
{
	/// <summary>
	/// Summary description for GraphScaleData.
	/// </summary>
	public class GraphScaleData
	{
		#region Member Data
		private PointF scale, indent, max, min;
		private Point scalenum;
		#endregion

		#region Properties

		public Point NumberOfScales
		{
			get{ return scalenum; }
			set{ scalenum = value; }
		}

		public PointF Scale
		{
			get{ return scale; }
			set{ scale = value; }
		}

		public PointF Indent
		{
			get{ return indent; }
			set{ indent = value; }
		}

		public PointF Max
		{
			get{ return max; }
			set{ max = value; }
		}

		public PointF Min
		{
			get{ return min; }
			set{ min = value; }
		}
		#endregion

		public GraphScaleData(PointF scale, PointF indent, PointF max, PointF min)
		{
			this.scale = scale;
			this.indent = indent;
			this.max = max;
			this.min = min;
		}
	}
}
