#include "StdAfx.h"
#include "DatalogCom.h"

bre20::DatalogCom::DatalogCom(): SerialCom()
{
}

bool bre20::DatalogCom::connectToEcu(String* com, int baud, int parity)
{
	int portnum = getPortName(com);

	port->Cnfg->BaudRate = (SerialPorts::LineSpeed)baud;
	port->Cnfg->PortName = String::Concat(S"COM",portnum.ToString());
	port->Cnfg->Parity = getParity(parity);
	port->Cnfg->ReceiveMode = true;

	return port->Open(portnum);
}

unsigned char bre20::DatalogCom::sendBlock1b(unsigned char commands __gc[]) __gc[]
{
	return send(commands,commands->Length);
}

unsigned char bre20::DatalogCom::sendBlock2b(unsigned char commands __gc[]) __gc[]
{
	return send(commands,commands->Length*2);
}
