#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;

namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class DataLogger : public System::Windows::Forms::TabPage
	{

	public:
		DataLogger();
		~DataLogger();

		virtual void setSpeed(String * str)
		{
			speed->Text = str;
		}
		virtual void setMap(String * str)
		{
			map->Text = str;
		}
		virtual void setRpm(String * str)
		{
			rpm->Text = str;
		}
		virtual void setTps(String * str)
		{
			tps->Text = str;
		}
		virtual void setCell(String * str)
		{
			cell->Text = str;
		}
		virtual void setCell(int x, int y)
		{
			cell->Text = String::Concat(x.ToString(),S", ",y.ToString());
		}
	private:
		private: System::Windows::Forms::TextBox *  rpm;
		private: System::Windows::Forms::TextBox *  map;
		private: System::Windows::Forms::TextBox *  speed;
 		private: System::Windows::Forms::TextBox *  tps;
		private: System::Windows::Forms::TextBox *  cell;
//		private: System::Windows::Forms::TextBox *  column;
		private: System::Windows::Forms::Label *  celllabel;//cell label
		private: System::Windows::Forms::Label *  label1;
		private: System::Windows::Forms::Label *  label2;
		private: System::Windows::Forms::Label *  label3;
		private: System::Windows::Forms::Label *  label5;



	};

}