#pragma once

//#include "Form1.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#include "HondaEcu.h"
#include "DevUtil.h"

namespace bre20
{
	/// <summary> 
	/// tab page with a grid
	/// </summary>
	public __gc class DevPage : public System::Windows::Forms::TabPage
	{

	public: 
		DevPage(void);
		DevPage(String * tabName, RomRep::HondaEcu * hecu);

	protected: 
		SimpleGrid::Grid *  grid;

		System::Windows::Forms::TextBox * maxpressbox;
		System::Windows::Forms::Label * maxpresslab;
		System::Windows::Forms::GroupBox *  maxgroup;

		System::Windows::Forms::GroupBox *  mapgroup;
		System::Windows::Forms::RadioButton* stock;
		System::Windows::Forms::RadioButton* map2bar;
		System::Windows::Forms::RadioButton* map25bar;
		System::Windows::Forms::RadioButton* motorola25bar;
		System::Windows::Forms::RadioButton* map3bar;

	protected:
		int x;
	//	RomRep::DevUtil* rom;
		RomRep::HondaEcu* honecu;
		String* type;

	private:
		void setupPage();
		void fillGrid();
		void updateColHeaders();
		//event shit
		System::Void grid_CellChanged(System::Object *  sender, SimpleGrid::CellEvent *  e);

		System::Void maxpressbox_Leave(System::Object *  sender, System::EventArgs *  e);

		System::Void stock_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void map2bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void map25bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void motorola25bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e);
		System::Void map3bar_CheckedChanged(System::Object *  sender, System::EventArgs *  e);

	private: System::Void rev_KeyPress(System::Object *  sender, System::Windows::Forms::KeyPressEventArgs *  e)
			 {
				 if(e->KeyChar == (char)13)
					 maxpressbox_Leave(NULL,NULL);
			 }
	};

}