#include "stdafx.h"
#include "NGFuelMap.h"

RomRep::NGFuelMap::NGFuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
	unsigned int multloc1, unsigned char mltarray __gc[], unsigned char fil __gc[], 
	int cscalarloc, int rscalarloc, int ind, int mod):Obd0FuelMap(x1,y1,loc,themap,multloc1,
	mltarray,fil,ind,mod)
{
	this->populate(themap,mltarray);

	this->vtec = false;
	this->boost = false;
	if(ind > 0)
		this->boost = true;
	revscalarloc = rscalarloc;
	pressscalarloc = cscalarloc;

	RomRep::Pm6Ng::calcPressureHeaders(cscalarloc,vac,fil,boost);
	RomRep::Pm6Ng::calcRpmHeaders(rscalarloc,rpm,fil,boost);

}