#pragma once
using namespace System;

#include "FuelMap.h"

namespace RomRep
{
	[Serializable] public __gc class Obd0FuelMap : public FuelMap
	{

	public:
		
		Obd0FuelMap(int crap);
		Obd0FuelMap(int x, int y);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc, unsigned char mltarray __gc[]);
		Obd0FuelMap(int x, int y,unsigned int loc, unsigned char themap __gc[,], unsigned int multloc, unsigned char mltarray __gc[],unsigned char fil __gc[]);

		virtual ~Obd0FuelMap();

		///--------- override musts:-----------///
		virtual float calculate(int x, int y, int intval);
		virtual int calculate(int x, int y, float mapval);

		virtual void getMultipliers(int x, float mlts __gc[]);
		virtual unsigned char getIntMultipliers() __gc[];
		virtual void populate(unsigned char map __gc[,], unsigned char mltarray __gc[]);	
	};
}