#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;

#include "datalogger.h"

namespace bre20
{
	/// <summary> 
	/// </summary>
	public __gc class Vt0LogPage : public bre20::DataLogger
	{
	public:
		Vt0LogPage();

		virtual void setMapImage(String * str)
		{
			calcmap->Text = str;
		}
		virtual void setVtec(String * str)
		{
			vtec->Text = str;
		}
		virtual void setKnock(String * str)
		{
			knock->Text = str;
		}

		virtual void setPrimaryO2(String * str)
		{
			primaryo2->Text = str;
		}

		virtual void setSecondaryO2(String * str)
		{
			secondaryo2->Text = str;
		}

	private:
		private: System::Windows::Forms::Label *  primaryo2label;
		private: System::Windows::Forms::TextBox *  primaryo2;
		
		private: System::Windows::Forms::Label *  secondaryo2label;
		private: System::Windows::Forms::TextBox *  secondaryo2;

		private: System::Windows::Forms::Label *  calcmaplabel;
		private: System::Windows::Forms::TextBox *  calcmap;

		private: System::Windows::Forms::Label *  knocklabel;
		private: System::Windows::Forms::TextBox *  knock;

		private: System::Windows::Forms::TextBox *  vtec;
		private: System::Windows::Forms::Label *  vteclabel;
	};

}