#include "stdafx.h"
#include "DevMaps.h"
#include "obd0vtececu.h"
#include "devutil.h"

RomRep::DevIgnMap::DevIgnMap(int x1, int y1, unsigned int loc, unsigned char themap __gc[,], 
							 unsigned char fil __gc[], int maxmapadd, int rscalarloc, int ind, 
							 int mod):VT0IgnMap(false,x1,y1,loc,themap,fil,
							 DevUtil::mapscalarloc,rscalarloc,ind,mod)
{
	/*populate(themap);

	this->vtec = false;
	if( ind > 0 )
		this->vtec = true;

	this->revscalarloc = rscalarloc;
	this->pressscalarloc = DevUtil::mapscalarloc;*/

    this->maxmapadd = maxmapadd;
	RomRep::VT0MapHelper::setRpmScalars(rscalarloc,rpm,fil,vtec);
	RomRep::DevUtil::calcHeaders(fil[maxmapadd],fil,vac);
}

void RomRep::DevIgnMap::setColumnHeader(int col, String* val)
{
	RomRep::ByteChange* bc = DevUtil::setHeader(true, col,val,this->thefile,vac);
	if(bc != NULL)
	{
		this->SendByteChangeRequest(bc->getLocation(), (unsigned char)bc->getByte());
//		this->MapHeaderChanged(col,-1,vac[col]);
	}
}
////*********************************************
////*********************************************
////*********************************************
////*********************************************

RomRep::DevFuelMap::DevFuelMap(int x1, int y1,unsigned int loc, unsigned char themap __gc[,], 
							   unsigned int multloc1, unsigned char mltarray __gc[], 
							   unsigned char fil __gc[], int maxmapadd, int rscalarloc, 
							   int ind, int mod):
								VT0FuelMap(false,x1,y1,loc,themap,multloc1,mltarray,
									fil,DevUtil::mapscalarloc,rscalarloc,ind,mod)
{
	/*this->populate(themap,mltarray);

	this->vtec = false;
	if( ind > 0 )
		this->vtec = true;

	revscalarloc = rscalarloc;
	pressscalarloc = DevUtil::mapscalarloc;*/

	this->maxmapadd = maxmapadd;
	RomRep::VT0MapHelper::setRpmScalars(rscalarloc,rpm,fil,vtec);
	RomRep::DevUtil::calcHeaders(fil[maxmapadd],fil,vac);
}

void RomRep::DevFuelMap::setColumnHeader(int col, String* val)
{
	RomRep::ByteChange* bc = DevUtil::setHeader(true,col,val,thefile,vac);
	if(bc != NULL)
	{
		this->SendByteChangeRequest(bc->getLocation(), (unsigned char)bc->getByte());
//		this->MapHeaderChanged(col,-1,vac[col]);
	}
}