#include "stdafx.h"
#include "DevParam.h"
#include "devutil.h"

bre20::DevParam::DevParam():VT0Param(){}
bre20::DevParam::DevParam(RomRep::VT0Ecu* ecu):VT0Param(ecu,ecu->getNumVtec()-3,ecu->getNumVtec()){
	setupPage();
}

void bre20::DevParam::setupPage()
{

	mapGrp = new GroupBox();
	mapsensor = new ComboBox();
	maplabel = new Label();
	this->Controls->Add(mapGrp);
	this->mapGrp->Controls->Add(mapsensor);
	this->mapGrp->Controls->Add(maplabel);

	this->mapGrp->Location = System::Drawing::Point(252, 172);
	this->mapGrp->Name = S"mapGrp";
	this->mapGrp->Size = System::Drawing::Size(170, 70);
	this->mapGrp->Text = S"Map Sensor";
	this->mapGrp->FlatStyle = FlatStyle::System;

	// 
	// label
	// 
	this->maplabel->Location = System::Drawing::Point(16, 20);
	this->maplabel->Name = S"maplabel";
	this->maplabel->Size = System::Drawing::Size(150, 16);
//	this->maplabel->TabIndex = 7;
	this->maplabel->Text = S"Map Sensor Type:";
	// 
	// mapsensor box
	// 
	this->mapsensor->Location = System::Drawing::Point(16, 40);
	this->mapsensor->Name = S"mapsensor";
	this->mapsensor->Size = System::Drawing::Size(140, 20);
	this->mapsensor->DropDownStyle = ComboBoxStyle::DropDownList;
//	this->mapsensor->TabIndex = 2;
	/*
	MAPSTOCK = 0;
	MAP2BAR = 1;
	MAP25BAR = 2;
	MAP3BAR = 3;
	MAPMOTOROLA25BAR = 4;
	*/
	this->mapsensor->Items->Add(S"Stock");
	this->mapsensor->Items->Add(S"GM 2 Bar");
	this->mapsensor->Items->Add(S"2.5 Bar");
	this->mapsensor->Items->Add(S"GM 3 Bar");
	this->mapsensor->Items->Add(S"Motorola 2.5 Bar");

	mapsensor->SelectedIndex = RomRep::DevUtil::getMapSensor(rom->getFile());

	this->mapsensor->add_SelectedIndexChanged(new EventHandler(this,combo_SelectedIndexChanged));
}

void bre20::DevParam::combo_SelectedIndexChanged(Object * sender, EventArgs* args)
{
	RomRep::DevUtil::recalcPressureHeaders(mapsensor->SelectedIndex,rom);
}