#include "StdAfx.h"
#include "ghdPM6Param.h"


bre20::GhdPM6Param::GhdPM6Param():PM6Param()
{
}
bre20::GhdPM6Param::GhdPM6Param(RomRep::HondaEcu* ecu): PM6Param(ecu)
{
}
void bre20::GhdPM6Param::init()
{
	int limit = (static_cast<RomRep::GhdPm6*>(rom))->getRevlimit();
	int idle = (static_cast<RomRep::GhdPm6*>(rom))->getIdle();
	revbox->Text = limit.ToString();
	idlebox->Text = idle.ToString();

	launchlabel = new Label();
	launchbox = new TextBox();

	this->Controls->Add(this->launchbox);
	this->Controls->Add(this->launchlabel);

	// 
	// label2
	// 
	this->launchlabel->Location = System::Drawing::Point(24, 72);
	this->launchlabel->Name = S"launchlabel";
	this->launchlabel->Size = System::Drawing::Size(48, 16);
	this->launchlabel->TabIndex = 1;
	this->launchlabel->Text = S"Launch:";
	// 
	// textBox2
	// 
	this->launchbox->Location = System::Drawing::Point(24, 88);
	this->launchbox->Name = S"launchbox";
	this->launchbox->Size = System::Drawing::Size(64, 20);
	this->launchbox->TabIndex = 3;
	this->launchbox->Text = S"";
	this->launchbox->Leave += new System::EventHandler(this, launchbox_Leave);
	this->launchbox->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, launch_KeyPress);


	int launch = (static_cast<RomRep::GhdPm6*>(rom))->getLaunchLimit();
	launchbox->Text = launch.ToString();
}

System::Void bre20::GhdPM6Param::launchbox_Leave(System::Object *  sender, System::EventArgs *  e)
{
	int limit = (static_cast<RomRep::GhdPm6*>(rom))->getLaunchLimit();
	int newrpm = getBoxVal(launchbox);

	if(limit == newrpm)
		return;
	if(newrpm<0)
	{
		launchbox->Text = limit.ToString();
		return;
	}
	(static_cast<RomRep::GhdPm6*>(rom))->setLaunchLimit(newrpm);
	limit = (static_cast<RomRep::GhdPm6*>(rom))->getLaunchLimit();
	launchbox->Text = limit.ToString();
}
