#pragma once

using namespace System;

#include "properties.h"
#include "logfile.h"

namespace bre20
{
	/// <summary> 
	/// Class with static members that will be globally available. These members
	/// are the first objects instantiated by the Form1 class. 
	/// </summary>
	public __gc class Globals
	{
	public:
		///Use this to write to the log file.
		static LogFileObj* LogFile;

		///Use this to set and retrieve properties.
		static Properties* Props;

		///Not used.
		Globals(){}
	};
}