//SimpleGrid::Grid *  grid;
#include "StdAfx.h"
#include "GridPage.h"
#include "child.h"
#include "Form1.h"
#include "ignRetardDialog.h"
#include "ArithDialog.h"
#include "ManagedUtil.h"

bre20::GridPage::GridPage(void): TabPage()
{
	grid = new SimpleGrid::Grid();
	
}

bre20::GridPage::GridPage(String * tabName, int columns, int rows, int modee): TabPage()
{
	mode = modee;//0 for fuel 1 for ign, 2 for nograph
	int colwidth = 40, rowheight =17;
	grid = new SimpleGrid::Grid();

	if(mode != MODE_NOGRAPH)
	{
		graph = new BGraphLib::MapGraphControl();
		graph->setSize(columns,rows);
		this->Controls->Add(graph);
	}
//	index = indexx;//0 for non vtec 1 for vtec
	lastnacol = columns;

	this->Enter += new System::EventHandler(this, tabPage1_Enter);

	this->contextMenu1 = new System::Windows::Forms::ContextMenu();
	this->plusOne = new System::Windows::Forms::MenuItem();
	this->plusFive = new System::Windows::Forms::MenuItem();
	this->minusFive = new System::Windows::Forms::MenuItem();
	this->minusOne = new System::Windows::Forms::MenuItem();
	this->copy = new System::Windows::Forms::MenuItem();
	this->paste = new System::Windows::Forms::MenuItem();
	this->multiply = new System::Windows::Forms::MenuItem();
	this->add = new System::Windows::Forms::MenuItem();
	

//	MessageBox::Show(this->Parent->ToString());

			System::Windows::Forms::MenuItem* __mcTemp__1[] = new System::Windows::Forms::MenuItem*[8];
			__mcTemp__1[0] = this->plusOne;
			__mcTemp__1[1] = this->plusFive;
			__mcTemp__1[2] = this->minusFive;
			__mcTemp__1[3] = this->minusOne;
			__mcTemp__1[4] = this->multiply;
			__mcTemp__1[5] = this->add;
			__mcTemp__1[6] = this->copy;
			__mcTemp__1[7] = this->paste;
			this->contextMenu1->MenuItems->AddRange(__mcTemp__1);

			// 
			// multiply
			// 
			this->multiply->Index = 4;
			this->multiply->Text = S"Multiply...";
			this->multiply->Shortcut = System::Windows::Forms::Shortcut::CtrlM;
			this->multiply->Click += new System::EventHandler(this, multiply_Click);
			// 
			// add
			// 
			this->add->Index = 5;
			this->add->Text = S"Add...";
			this->add->Shortcut = System::Windows::Forms::Shortcut::CtrlA;
			this->add->Click += new System::EventHandler(this, add_Click);
			// 
			// paste
			// 
			this->paste->Index = 7;
			this->paste->Text = S"Paste";
			this->paste->Shortcut = System::Windows::Forms::Shortcut::CtrlV;
			this->paste->Click += new System::EventHandler(this, paste_Click);
			// 
			// copy
			// 
			this->copy->Index = 6;
			this->copy->Text = S"Copy";
			this->copy->Shortcut = System::Windows::Forms::Shortcut::CtrlC;
			this->copy->Click += new System::EventHandler(this, copy_Click);
			// 
			// plusOne
			// 
			this->plusOne->Index = 0;
			this->plusOne->Text = S"+ 1%";
			this->plusOne->Click += new System::EventHandler(this, plus1_Click);
			this->plusOne->Shortcut = System::Windows::Forms::Shortcut::CtrlI;
			// 
			// plusFive
			// 
			this->plusFive->Index = 1;
			this->plusFive->Text = S"+ 5%";
			this->plusFive->Click += new System::EventHandler(this, plus5_Click);
			this->plusFive->Shortcut = System::Windows::Forms::Shortcut::CtrlShiftI;
			// 
			// minusFive
			// 
			this->minusFive->Index = 2;
			this->minusFive->Text = S"- 5%";
			this->minusFive->Click += new System::EventHandler(this, minus5_Click);
			this->minusFive->Shortcut = System::Windows::Forms::Shortcut::CtrlShiftD;
			// 
			// minusOne
			// 
			this->minusOne->Index = 3;
			this->minusOne->Text = S"- 1%";
			this->minusOne->Click += new System::EventHandler(this, minus1_Click);
			this->minusOne->Shortcut = System::Windows::Forms::Shortcut::CtrlD;


	this->Controls->Add(grid);
	this->Text = tabName;

	
	this->grid->Size = System::Drawing::Size(grid->RowHeaderWidth + (columns*colwidth), rowheight+(rows*rowheight));
	this->grid->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left) 
				| System::Windows::Forms::AnchorStyles::Right);
	this->grid->BackColor = System::Drawing::SystemColors::Window;
	this->grid->Location = System::Drawing::Point(0, 0);
	this->grid->RowHeaderWidth = 50;
	this->grid->SelectedForeColor = System::Drawing::Color::White;
	this->grid->SelectedRowColor = System::Drawing::Color::Blue;
	this->grid->TabStop = false;
	this->grid->Name = S"grid";
	this->grid->GridSize = System::Drawing::Size(columns, rows);
	this->grid->setAllColumnWidths(colwidth);
	this->grid->RowHeight = rowheight;
	//this->grid->GridSize.Width = columns;
	//this->grid->GridSize.Height = rows;
	this->grid->CellChanged += new SimpleGrid::GridChangedHandler(this, grid_CellChanged);
	this->grid->Size = this->Size;

//	grid->Visible = false;

	this->TabStop = false;

	

	if(mode != MODE_NOGRAPH)
	{
		graph->Location = System::Drawing::Point(0, 0);
		//setup later
	//	graph.Map = fuelMap;
	//	graph.RpmList = rpmList;
		graph->Width = this->ClientRectangle.Width;
		graph->Height = this->ClientRectangle.Height;
		graph->NodeMoved += new BGraphLib::MapGraphControl::UpdateHandler(this,mapPlot_NodeMoved);
		graph->Anchor = (System::Windows::Forms::AnchorStyles)(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
					| System::Windows::Forms::AnchorStyles::Left) 
					| System::Windows::Forms::AnchorStyles::Right);
		graph->Visible = false;
	}

//	for(i = 0; i<columns; i++)
//		for(j = 0; j<rows; j++)
//			grid->setValue(i,j,data[i][j]);

	this->ContextMenu = contextMenu1;


//	this->add_Enter(new System::EventHandler(this, this_Enter));
}
void bre20::GridPage::clearGrid()
{
	for(int i = 0; i < grid->GridSize.Width; i++)
		for(int j = 0; j < grid->GridSize.Height; j++)
			grid->setValue(i,j,"");

	grid->Refresh();
}
void bre20::GridPage::addExtraContext()
{
	
	System::Windows::Forms::MenuItem * tmp = new System::Windows::Forms::MenuItem();
	
	tmp->Text = S"-";

	insertCol = new System::Windows::Forms::MenuItem();
	
	
	this->insertCol->Text = S"Insert Column";
	this->insertCol->Click += new System::EventHandler(this, insertCol_Click);
	this->insertCol->Enabled = false;

	this->contextMenu1->MenuItems->Add(8,tmp);
	this->contextMenu1->MenuItems->Add(9,insertCol);

	if(mode == 1)
	{
		this->ignRetard = new System::Windows::Forms::MenuItem();
		this->ignRetard->Text = S"Boost Ignition Retard";
		this->ignRetard->Click += new System::EventHandler(this, ignRetard_Click);
		this->contextMenu1->MenuItems->Add(9,ignRetard);
	}

}

void bre20::GridPage::setLastNaCol(int lnac)
{
	lastnacol = lnac;

}

System::Void bre20::GridPage::ignRetard_Click(System::Object *  sender, System::EventArgs *  e)
{
	IgnRetardDialog* ird = new IgnRetardDialog(this,lastnacol);

	ird->Show();
	ird->TopMost = true;
}

System::Void bre20::GridPage::insertCol_Click(System::Object *  sender, System::EventArgs *  e)
{
//	(static_cast<child*>(this->Parent->Parent))->insertColumn(this->grid->getMouseOverCol());
//	this->grid->Refresh();
}

void bre20::GridPage::setSelection(int x, int y, int w, int h, bool refresh)
{
	grid->SelectedColumn = x;
	grid->SelectedRow = y;
	grid->LastSelectedColumn = (x+w-1);
	grid->LastSelectedRow = (y+h-1);

	if(refresh)
		grid->Refresh();
}


void bre20::GridPage::setCellColor(int column, int row, Color color)
{
	if(column<grid->GridSize.Width && row<grid->GridSize.Height)
		grid->setCellColor(column,row,color);
}
String* bre20::GridPage::getColumnHeader(int column)
{
	return grid->getHeader(column);
}
void bre20::GridPage::setColumnHeader(int column, String * str)
{
	grid->setHeader(column, str);
	if(mode != MODE_NOGRAPH)
		graph->setCol(column, grid->getHeader(column));

	SimpleGrid::CellEvent* ce = new SimpleGrid::CellEvent();
	ce->Column = column;
	ce->Row = -1;
	this->onColHeaderChanged(ce);
}

void bre20::GridPage::setGridColumnHeader(int column, String * str)
{
	grid->setHeader(column, str);

	SimpleGrid::CellEvent* ce = new SimpleGrid::CellEvent();
	ce->Column = column;
	ce->Row = -1;
	this->onColHeaderChanged(ce);
}
String* bre20::GridPage::getRowHeader(int row)
{
	return grid->getRowHeader(row);
}
void bre20::GridPage::setRowHeader(int row, String * str)
{
	grid->setRowHeader(row,str);

	SimpleGrid::CellEvent* ce = new SimpleGrid::CellEvent();
	ce->Column = -1;
	ce->Row = row;
	this->onColHeaderChanged(ce);
}

void bre20::GridPage::setColumnWidth(int col,int width)
{
	this->grid->setColumnWidth(col,width);
}

//*******************gets

float bre20::GridPage::getColumnHeaderDbl(int column)
{
	String* str = grid->getHeader(column);

	return ManagedUtil::stringToSingle(str);
}

//***********************

void bre20::GridPage::setupGraph()
{
//	need to create float map
//	need to create rpm list
	//float mapp __gc[,]= new float __gc[grid->GridSize.Width,grid->GridSize.Height];
	//int rpm __gc[] = new int __gc[grid->GridSize.Height]; 

	if(mode != MODE_NOGRAPH)
	{
		for(int row = 0; row< grid->GridSize.Height; row++)
		{
			graph->setRow(row, Convert::ToInt32(grid->getRowHeader(row)));
			for(int col = 0; col< grid->GridSize.Width; col++)
			{	
			//	graph->setCol(col, grid->getHeader(col));
				graph->setValue(col,row, grid->getValue(col,row));//graph->Map	
			}
		}
	//	graph->Map = mapp;
	//	graph->RpmList = rpm;
		graph->setupHeaders();	
	}
}

void bre20::GridPage::changeView(bool table)
{
	if(mode != MODE_NOGRAPH)
		if(table)
		{
			graph->Visible = false;
			grid->Visible = true;
		}	
		else
		{
			graph->Visible = true;
			grid->Visible = false;
		}
}

void bre20::GridPage::setValue(int column, int row, float value, bool event)
{
	if(column<grid->GridSize.Width && row<grid->GridSize.Height)
	{
		grid->setValue(column, row, value);
		try
		{
			if(mode != MODE_NOGRAPH)
				graph->setValue(column,row,grid->getValue(column,row));
		}
		catch(...){}

		if(event)
		{
			SimpleGrid::CellEvent* ce = new SimpleGrid::CellEvent();
			ce->Column = column;
			ce->Row = row;

			this->onCellChanged(ce);
		}
	}
}

float bre20::GridPage::getValue(int column, int row)
{
	try{
		return grid->getValue(column, row);
	}catch(...){return 0.0F;}
}

//System::Void bre20::GridPage::this_Enter(System::Object *  sender, System::EventArgs *  e)
//{

//}

System::Void bre20::GridPage::multiply_Click(System::Object *  sender, System::EventArgs *  e)
{
	ArithDialog* ad = new ArithDialog("Multiply selection by...");
	ad->setNumber(1.0);
	ad->ShowDialog();

	float val = ad->getNumber();

	if(val != 1.0)
		changeRange(5,val);

}

System::Void bre20::GridPage::add_Click(System::Object *  sender, System::EventArgs *  e)
{
	ArithDialog* ad = new ArithDialog("Add to selection...");
	ad->setNumber(0.0);
	ad->ShowDialog();

	float val = ad->getNumber();

	if(val != 0.0)
		changeRange(6,val);
}

System::Void bre20::GridPage::copy_Click(System::Object *  sender, System::EventArgs *  e)
{
	int selected __gc[]= getSelectedCells();

	StringBuilder* sb = new StringBuilder();
	
	//i = row f, j = col f, k = row l, l = col l

	if(selected == NULL)
		return;

	for(int y = selected[1]; y<=selected[3]; y++)
	{
		for(int x = selected[0]; x<=selected[2]; x++)
		{
//			array->setVal(x-selected[0],y-selected[1],grid->getValue(x,y));
			sb->Append(grid->getValue(x,y).ToString());

			if(x!=selected[2])
				sb->Append(S"\t");

		}

		if(y!=selected[3])
			sb->Append(S"\n");
	}

//	IDataObject* d = Clipboard::GetDataObject();
//	d->SetData(DataFormats::Text, sb->ToString());
	Clipboard::SetDataObject(sb->ToString());


//	MessageBox::Show(sb->ToString());

//	delete[] selected;

//	(static_cast<bre20::Form1*>(this->Parent->Parent->Parent->Parent))->setClipboard(array);
//	MessageBox::Show(this->Parent->Parent->Parent->Parent->);
}

System::Void bre20::GridPage::paste_Click(System::Object *  sender, System::EventArgs *  e)
{

	int colfirst = grid->SelectedColumn;
	int rowfirst = grid->SelectedRow;
	
	if(rowfirst<0)// || clip == NULL || mode!=clip->getMode())
		return;
	
	String* nums;
	IDataObject * data = Clipboard::GetDataObject();
	if (data->GetDataPresent(DataFormats::Text))
		nums = data->GetData(DataFormats::Text)->ToString();

	//parse data
	String* delim = S"\n";
	String* delimT = S"\t";
	String* rows[] = nums->Split(delim->ToCharArray());

	int width;
	float clip __gc[,];
	if(rows->Length >0)
	{
		String* rowvals[] = rows[0]->Split(delimT->ToCharArray());
		clip = new float __gc[rowvals->Length, rows->Length];
		width = rowvals->Length;
		for(int row = 0; row<rows->Length; row++)
		{
			rowvals = rows[row]->Split(delimT->ToCharArray());
			for(int col = 0; col<width; col++)
			{
				try
				{
					clip[col,row] = Convert::ToSingle(rowvals[col]);
				}
				catch(...)
				{
					return;
				}
			}
		}
	}
	else 
		return;
	//end parsing

	SimpleGrid::CellEvent* noo = new SimpleGrid::CellEvent();

	for(int i = colfirst; (i-colfirst)<width; i++)
		for(int j = rowfirst; (j-rowfirst)<rows->Length; j++)
		{
			if(i<grid->GridSize.Width && j<grid->GridSize.Height)
			{
				noo->Column = i;
				noo->Row = j;

				float newvalue = clip[i-colfirst,j-rowfirst];
				
				if(newvalue > 2.0)
					newvalue += .01F;

				grid->setValue(i,j,newvalue);

				onCellChanged(noo);
			}
		}

	
	grid->Refresh();
}
int bre20::GridPage::getSelectedCells() __gc[]//returns indicies of selected cells
{
	int collast, colfirst, rowlast, rowfirst;

	collast = grid->LastSelectedColumn;
	colfirst = grid->SelectedColumn;
	rowlast = grid->LastSelectedRow;
	rowfirst = grid->SelectedRow;

	if(rowfirst < 0)
		return NULL;
	if(collast < 0 || rowlast < 0)
	{
		collast = colfirst;
		rowlast = rowfirst;
	}

	int i, //rowfirst
		j, //colfirst
		k, //rowlast
		l; //col last

	if (colfirst < collast && rowfirst < rowlast)//down & right
	{
		i = rowfirst;
		j = colfirst;
		k = rowlast;
		l = collast;

	}
	if (collast < colfirst && rowlast < rowfirst)//up & left
	{
		i = rowlast;
		j = collast;
		k = rowfirst;
		l = colfirst;
	}
	if (collast < colfirst && rowfirst < rowlast)//down & left
	{
		i = rowfirst;
		j = collast;
		k = rowlast;
		l = colfirst;
	}
	if (colfirst < collast && rowlast < rowfirst)
	{
		i = rowlast;
		j = colfirst;
		k = rowfirst;
		l = collast;
	}
	if (colfirst == collast && rowlast < rowfirst)
	{
		i = rowlast;
		j = colfirst;
		k = rowfirst;
		l = collast;
	}
	if (colfirst == collast && rowlast > rowfirst)
	{
		k = rowlast;
		j = colfirst;
		i = rowfirst;
		l = collast;
	}
	if (colfirst < collast && rowlast == rowfirst)
	{
		i = rowlast;
		j = colfirst;
		k = rowfirst;
		l = collast;
	}
	if (colfirst > collast && rowlast == rowfirst)
	{
		i = rowlast;
		l = colfirst;
		k = rowfirst;
		j = collast;
	}
	if (colfirst == collast && rowlast == rowfirst)
	{
		i = rowlast;
		j = colfirst;
		k = rowfirst;
		l = collast;
	}
	//i = row f, j = col f, k = row l, l = col l

	//returns top left and bottom right cell index
	// {col topL, row topL, col bottR, row bottR}

	int aray __gc[] = new int __gc[4];

	aray[0] = j;
	aray[1] = i;
	aray[2] = l;
	aray[3] = k;

	return aray;
}

void bre20::GridPage::changeRange(int mode, float scal)//float (*fp)(int,int))
{

	int selected __gc[] = getSelectedCells();
	
	if(selected == NULL)
		return;
	//i = row f, j = col f, k = row l, l = col l
	//selected[1], selected[0], selected[3], selected[2]
	SimpleGrid::CellEvent* noo = new SimpleGrid::CellEvent();

	for(int x = selected[0]; x<=selected[2]; x++)
		for(int y = selected[1]; y<=selected[3]; y++)
		{
			noo->Column = x;
			noo->Row = y;

			if( mode == 1)
				grid->setValue(x,y,plus1(x,y));
			else if (mode == 2)
				grid->setValue(x,y,plus5(x,y));
			else if (mode == 3)
				grid->setValue(x,y,minus5(x,y));
			else if (mode == 4)
				grid->setValue(x,y,minus1(x,y));
			else if (mode == 5)
				grid->setValue(x,y,multiplyBy(x,y,scal));
			else if (mode == 6)
				grid->setValue(x,y,addNum(x,y,scal));

			onCellChanged(noo);	
		}
		delete[] selected;

		grid->Refresh();
		
}

void bre20::GridPage::mapHeaderChanged(Object* sender, RomRep::MapHeaderChangeArgs* args)
{
	//this only deals with the column changes 
	if(args->getX() == RomRep::Map::HEADER_EVENT_ALL)
	{
		String* h[] = args->getValue();
		for(int i = 0; i<h->Length; i++)
			this->setColumnHeader(i,h[i]);
		grid->Refresh();
	}
	else if(args->getX() != RomRep::Map::HEADER_EVENT_NONE){
		this->setColumnHeader(args->getX(),args->getValue()[0]);
		grid->Refresh();
	}
}

