#pragma once

using namespace System;
using namespace System::Windows::Forms;
using namespace System::Collections;
using namespace SimpleGrid;

namespace bre20
{

	public __gc class LoggerGrid: public Grid
	{
	public: 
		LoggerGrid(int width, int height);

		///Sets up the grid by creating the rows, sizing the columns,
		///and putting the labels/keys in the grid.
		///
		///Will be called when the Logger start button is clicked. This 
		///is slower than update grid. Values in the list are of type
		///LoggerKey.
		void InitGrid(ArrayList* newvals);

		//Updates the values in the grid. Called on each data retrieval 
		//from the ecu.Values in the list are of type LoggerKey.
	//	UpdateGrid(ArrayList* newvals);

		void setKeyValue(int row, String* value);
		void setKeyValue(int row, String* key, String* value);
	};
}