#include "stdafx.h"
#include "Pr3ITBParam.h"
#include "JdmPr3ITB.h"
#include "child.h"

bre20::Pr3ITBParam::Pr3ITBParam():VT0Param(){}
bre20::Pr3ITBParam::Pr3ITBParam(RomRep::HondaEcu* ecu):VT0Param(ecu,5,8)
{

	setupPage();
}

System::Void bre20::Pr3ITBParam::xover_Leave(System::Object *  sender, System::EventArgs *  e)
{
	String * str = xover->Text;

	int column = getBoxVal(xover);

	if(column<14 && column>=0)
	{
		(static_cast<RomRep::JdmPr3ITB*>(rom))->setXoverCol(column);
//		(static_cast<child*>(this->Parent->Parent))->setAllColHeaders();
	}
	else
	{
		int cross = (static_cast<RomRep::JdmPr3ITB*>(rom))->getXoverCol();
		xover->Text = cross.ToString();
	}

}

void bre20::Pr3ITBParam::setupPage()
{

	xoverGrp = new GroupBox();
	xover = new TextBox();
	xoverlabel = new Label();
	this->Controls->Add(xoverGrp);
	this->xoverGrp->Controls->Add(xover);
	this->xoverGrp->Controls->Add(xoverlabel);

	this->xoverGrp->Location = System::Drawing::Point(252, 172);
	this->xoverGrp->Name = S"xoverGrp";
	this->xoverGrp->Size = System::Drawing::Size(170, 70);
	this->xoverGrp->Text = S"ITB Crossover";
	this->xoverGrp->FlatStyle = FlatStyle::System;

	// 
	// label
	// 
	this->xoverlabel->Location = System::Drawing::Point(16, 20);
	this->xoverlabel->Name = S"xoverlabel";
	this->xoverlabel->Size = System::Drawing::Size(150, 16);
//	this->xoverlabel->TabIndex = 7;
	this->xoverlabel->Text = S"TPS xover (column):";
	// 
	// xover box
	// 
	this->xover->Location = System::Drawing::Point(16, 40);
	this->xover->Name = S"xover";
	this->xover->Size = System::Drawing::Size(64, 20);
//	this->xover->TabIndex = 2;
	this->xover->Text = S"";

	int cross = (static_cast<RomRep::JdmPr3ITB*>(rom))->getXoverCol();
	xover->Text = cross.ToString();
	
	this->xover->Leave += new System::EventHandler(this, xover_Leave);
	this->xover->KeyPress += new System::Windows::Forms::KeyPressEventHandler(this, xover_KeyPress);
}
