//#pragma unmanaged
//
//#ifndef BENS_RPM_VALUE_H
//#define BENS_RPM_VALUE_H

#pragma once
using namespace System;

//#include<iostream>

namespace RomRep
{
	[Serializable] public __gc class RpmByteValue: public MarshalByRefObject
	{

	private:

		int byte1;
		unsigned int loc1;

	public:
		RpmByteValue();
		RpmByteValue(unsigned int loc, int bite);

		void setByte(int val);
		void setLocation(int val);
		void setBoth(int loc, int bite);
		int getByte(){return byte1;};

		unsigned int getLocation(){return loc1;};
	};

	[Serializable] public __gc class RpmTwoByteValue: public MarshalByRefObject
	{
	private:

		int byte1;
		int byte2;
		unsigned int loc1, loc2;

	public:
		RpmTwoByteValue();
		RpmTwoByteValue(unsigned int loc01, unsigned int loc02);
		RpmTwoByteValue(unsigned int loc01, int bite1, unsigned int loc02, int bite2);

		void setByte1(int val);
		int getByte1(){return byte1;};
		
		void setByte2(int val);
		int getByte2(){return byte2;};

		int getTwoByte(){return byte1*256+byte2;}
		void setBoth(int addy,int bite,int addy2, int bite2)
		{byte1 = bite; byte2 = bite2; loc1 = addy; loc2 = addy2;}

		unsigned int getLocation1(){return loc1;};
		unsigned int getLocation2(){return loc2;};

	};
}

//#endif
