#pragma unmanaged

#if !defined BENS_OBD0FUELMAP_H
#define BENS_OBD0FUELMAP_H

#include "FuelMap.h"
#include <Cmath>

namespace RomRep
{
	class Obd0FuelMap : public FuelMap
	{

	public:
		
		Obd0FuelMap(int crap = 0);
		Obd0FuelMap(int x, int y);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc);
		Obd0FuelMap(int x, int y, unsigned int loc, unsigned int mltloc, int* mltarray);
		Obd0FuelMap(int x, int y,unsigned int loc, int** themap, unsigned int multloc, int* mltarray,int* fil);

		virtual ~Obd0FuelMap();

		///--------- override musts:-----------///
		virtual double calculate(int x, int y, int intval);
		virtual int calculate(int x, int y, double mapval);

		void getMultipliers(int x, double* mlts);
		virtual const int* getIntMultipliers();
		virtual void populate(int ** map, int * mltarray);	
	};
}

//	ostream& operator<<(ostream& out, Obd0FuelMap& fm);

#endif