#pragma unmanaged

#pragma once
#if !defined BENSs_OBD0OBD0PR3ECU_H
#define BENSs_OBD0OBD0PR3ECU_H

#include "Obd0VtecEcu.h"
namespace RomRep
{
	class Obd0Pr3: public VT0Ecu
	{
	public:
		Obd0Pr3();
		Obd0Pr3(int* rom, int flen);

		virtual void disableChecksum(bool disable); 
		virtual void disableOxygenSensors(bool disable);
		virtual void disable2ndOxygenSensor(bool disable);

		virtual void setLaunchRpm(int val);
		virtual void setLaunchSpeed(int val);
		virtual void enableLaunch(bool enable);
		virtual void disableSpeedLimiter(bool disable); 
		virtual void disableVssCheck(bool disable); 
		virtual void disableTempCheck(bool disable); 
		virtual void disablePsCheck(bool disable); 
		virtual void disableCelCheck(bool disable);
		virtual void disableKnockSensor(bool disable);
		virtual void disableCodes(bool disable);

		virtual int getLaunchRpm();
		virtual int getLaunchSpeed();

		virtual int isSpeedLimiterDisabled();
		virtual int isVssCheckDisabled();
		virtual int isTempCheckDisabled();
		virtual int isCelCheckDisabled();
		virtual int isPsCheckDisabled();
		virtual int isLaunchDisabled();
		virtual int isKnockSensorDisabled();
		virtual int isCodesDisabled();
		
		virtual int is2ndOxygenSensorDisabled();

		virtual int isChecksumDisabled();
		virtual int isOxygenSensorsDisabled();

		virtual int isCodeBitDisable(int code);
		virtual int codeBitDisable(int code, bool disable);
		virtual int isCodeBitDisabled(int code);

		static bool validate(int* h);

	//private:
	//	static int head[10]; //HondaEcu::headlen
	};
}
//ostream& operator<<(ostream& out, JdmPw0& pw0);

#endif