#include "stdafx.h"

#include "RpmValue.h"

RomRep::RpmByteValue::RpmByteValue()
{
	byte1 = 0;
	loc1 = 0;
}

RomRep::RpmByteValue::RpmByteValue(unsigned int loc, int bite)
{
	byte1 = bite;
	loc1 = loc;
}

void RomRep::RpmByteValue::setByte(int val)
{byte1 = val;}

void RomRep::RpmByteValue::setLocation(int val)
{
	loc1 = val;
}

void RomRep::RpmByteValue::setBoth(int loc, int bite)
{
	loc1 = loc;
	byte1 = bite;
}

////-------------------------

RomRep::RpmTwoByteValue::RpmTwoByteValue()
{
	byte1 = byte2 = 0;
	loc1 = loc2 = 0;
}

RomRep::RpmTwoByteValue::RpmTwoByteValue(unsigned int loc01, unsigned int loc02)
{
	byte1 = byte2 = 0;
	loc1 = loc01;
	loc2 = loc02;
}

RomRep::RpmTwoByteValue::RpmTwoByteValue(unsigned int loc01, int bite1, unsigned int loc02, int bite2)
{
	byte1 = bite1;
	byte2 = bite2;
	loc1 = loc01;
	loc2 = loc02;
}

void RomRep::RpmTwoByteValue::setByte1(int val)
{byte1 = val;}
	
void RomRep::RpmTwoByteValue::setByte2(int val)
{byte2 = val;}